Subject: bug#10280: ruby-mode.el - Unknown finder.el keyword: ruby

From: Drew Adams <[email-masked]>
Date: Sun, 11 Aug 2019 18:03:19 -0700 (PDT)

> >>     ;; Keywords: languages ruby
> >>
> >> However word "ruby" is not in list returned by M-x finder-list-
> >> keywords. Perhaps finder-list-keywords or ruby.el should be updated.
> >
> > Free-form user-defined keywords are allowed since the list of
> > keywords is open-ended.  So this is rather a shortcoming of
> > `finder-list-keywords'

No, it's not a shortcoming.  It's open-ended by design,
AFAIK, and that's good.

> > that doesn't yet list all keywords beyond a few of "official" ones.

And it shouldn't, IMO.  list `finder-known-keywords'
should remain something defined by Emacs.

On the other hand, `finder.el' could be enhanced
to provide such a feature as an _option_.  It
could have a user option whose value is a list
of additional keywords to recognize.

That's the approach we take with Dired guessing
shell-command associations.  We have a non-option
variable, `dired-guess-shell-alist-default', which
is defines the default associations, and we have
a user option, `dired-guess-shell-alist-user',
which is prepended to the default list.

That would let users control the behavior of
`finder-list-keywords'.  After all, that's a
command - it's for users.

> Do we really want to change finder-list-keywords to list all keywords?
> (For some definition of "all".)

No, we don't; that is, I don't.

Field `Keywords' is _not_ just for `finder.el'.
It's for anything a library writer (or user) wants
it to be for.

(I believe it predates `finder.el', but I'm not sure
of that.)

> Wouldn't that make the menu much harder to navigate?

Yes.  If we want to let users choose that, and choose
how much harder (which and how many extra keywords),
that's fine, however.